pub mod input;
pub mod output;

pub use physical::transducer::*;

#[cfg(feature = "embassy-sync")]
use embassy_sync::blocking_mutex::raw::RawMutex;
#[cfg(feature = "embassy-sync")]
use embassy_sync::pubsub;
#[cfg(feature = "embassy-sync")]
use embassy_sync::pubsub::Subscriber;

#[cfg(feature = "embassy-sync")]
pub trait Publisher<const CAPACITY: usize, const NUM_SUBS: usize> {
    type Value: Copy;
    type Mutex: RawMutex;

    fn subscribe(
        &self,
    ) -> Result<Subscriber<Self::Mutex, Self::Value, CAPACITY, NUM_SUBS, 0>, pubsub::Error>;
}
