use crate::cell::CellView;

pub mod input;
pub mod output;
mod conversion;

// Initialisation will always be async and won't complete until a state is available for all
// stateful transducers.
pub trait Stateful {
    type Value: Copy;

    fn state_cell(&self) -> CellView<Self::Value>;

    #[inline(always)]
    fn state(&self) -> Self::Value {
        self.state_cell().get()
    }
}
